<%-- $Id: overview.jsp 4767 2009-02-17 14:01:28Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2009 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.overview.GenericOverview"
	import="net.sf.basedb.util.overview.OverviewUtil"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final int itemId = Values.getInt(request.getParameter("item_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final DbControl dc = null;
final String root = request.getContextPath();
try
{
	%>
	<base:page type="include">
	<base:body>
		<script language="JavaScript">
		var timer = 0;
		var inCall = false;
		function adjustIFrameSize()
		{
			if (inCall) return;
			inCall = true;
			var iframeElement = document.getElementById("idOverview");
			// Find the top coordinate of the IFrame
			var offsetTop = 10;
			var offsetTrail = iframeElement;
			while (offsetTrail)
			{
				offsetTop += offsetTrail.offsetTop;
				offsetTrail = offsetTrail.offsetParent;
			}
	
			// Find the browser window height
			var windowHeight = Main.getWindowHeight();
			iframeElement.height = windowHeight-offsetTop;
	
			// Adjust the height of the frames
			var iframe = window.frames['overview'];
			var tree = iframe.frames['tree'].document.getElementById('main');
			if (tree) tree.style.height = (iframeElement.height-8)+'px';
			var joust = iframe.frames['tree'].document.getElementById('joust');
			if (joust) joust.style.height = (iframeElement.height-8)+'px';
			var info = iframe.frames['info'].document.getElementById('main');
			if (info) info.style.height = iframeElement.height+'px';
			inCall = false;
		}
		function setTimer()
		{
			if (inCall) return;
			if (timer) clearTimeout(timer);
			timer = setTimeout('adjustIFrameSize()', 150);
		}
		function expandAll()
		{
			frames['overview']['tree'].openAll();
		}
		function collapseAll()
		{
			frames['overview']['tree'].closeAll();
		}
		function revalidate()
		{
			var url = '<%=root%>/common/overview/index.jsp?ID=<%=ID%>';
			url += '&cmd=Revalidate';
			url += '&item_type=<%=itemType.name()%>';
			url += '&item_id=<%=itemId%>';
			frames['overview'].location.href = url;
		}
		function validationOptions()
		{
			frames['overview'].Main.openPopup('<%=root%>/common/overview/options.jsp?ID=<%=ID%>', 'ValidationOptions', 700, 500);
		}
		if (window.addEventListener)
		{
			window.addEventListener('resize', setTimer, false);
		}
		else if (window.attachEvent)
		{
			window.attachEvent('onresize', setTimer);
		}
		</script>
			<tbl:toolbar>
				<tbl:button image="joust/plusonly.gif" title="Expand all"
					onclick="expandAll()" tooltip="Expand entire tree"/>
				<tbl:button image="joust/minusonly.gif" title="Collapse all" 
					onclick="collapseAll()" tooltip="Collapse entire tree" />
				<tbl:button image="refresh.gif" title="Revalidate" 
					onclick="revalidate()" tooltip="Revalidate the experiment" />
				<tbl:button image="configure.png" title="Validation options&hellip;" 
					onclick="validationOptions()" tooltip="Change validation options" />
				<tbl:button image="help.gif" title="Help&hellip;"
					onclick="<%="Main.openHelp('" + ID +"', 'item.overview')"%>"
					tooltip="Get help about this page"
				/>	
			</tbl:toolbar>
			<iframe name="overview" id="idOverview" 
				src="<%=root%>/common/overview/index.jsp?ID=<%=ID%>&cmd=Overview&item_type=<%=itemType.name()%>&item_id=<%=itemId%>" 
				frameborder="0" vspace="0" hspace="0"
				marginwidth="0" marginheight="0" scrolling="no" 
				style="width: 100%; border: 1px solid #999999; border-top: 0px; overflow: visible"></iframe>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
