<%-- $Id: list_directories.jsp 4744 2009-02-10 07:37:57Z martin $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.FileUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.Map"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%!
String generateSubTree(Map<Directory, List<Directory>> tree, Directory parent, String ID, String parentId)
{
	StringBuilder sb = new StringBuilder();
	if (parentId == null) parentId = "dir"+parent.getId();
	List<Directory> children = tree.get(parent);
	if (children == null) return "";
	for (Directory child : children)
	{
		String folderIcon = "Folder";
		if (child.isHomeDirectory())
		{
			folderIcon = "UserHome";
		}
		else if (child.isRemoved())
		{
			folderIcon = "FolderDeleted";
		}
		else if (child.getAutoCompress())
		{
			folderIcon = "FolderCompressed";
		}
		sb.append("var dir").append(child.getId()).append(" = JoustMenu.addChildItem(").append(parentId);
		sb.append(",'").append(folderIcon).append("'");
		sb.append(",'").append(HTML.javaScriptEncode(child.getName())).append("'");
		sb.append(",'directoryOnClick(").append(child.getId()).append(",");
		sb.append(" \"").append(HTML.javaScriptEncode(child.getPath().toString())).append("\")'");
		sb.append(",'', 'D").append(child.getId()).append("')\n");
		sb.append(generateSubTree(tree, child, ID, null));
	}
	return sb.toString();
}
%>
<%
final Item itemType = Item.DIRECTORY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
final String mode = request.getParameter("mode");
final String callback = request.getParameter("callback");
final float scale = Base.getScale(sc);
final String requestTitle = request.getParameter("title");
final ItemContext cc = sc.getCurrentContext(itemType);
int directoryId = cc.getId();
try
{
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final Directory userHome = user.getHomeDirectory();
	final boolean readDirectories = sc.hasPermission(Permission.READ, Item.DIRECTORY);
	final Directory root = Directory.getById(dc, SystemItems.getId(readDirectories ? Directory.ROOT : Directory.HOME));	

	final String rootIcon;
	final String rootTitle;
	if (root.isRootDirectory())
	{
		rootIcon = "Root";
		rootTitle = "Root";
	}
	else
	{
		rootIcon = "Home";
		rootTitle = "Other users";
	}
	Map<Directory, List<Directory>> tree = FileUtil.getDirectoryTree(dc, root);
	%>
	<base:page title="<%=requestTitle != null ? requestTitle : ""%>" type="popup">
	<base:head scripts="newjoust.js,table.js" styles="newjoust.css,toolbar.css">
	<script language="JavaScript">
	var isInitialised = false;
	function initialise() 
	{
		if (parent && parent.parent && parent.parent.adjustIFrameSize) parent.parent.adjustIFrameSize();
		IconStore.init();
		<%
		if (userHome != null)
		{
			%>
			var userHome = JoustMenu.addMenuItem(-1, 'Home', 'My home', 'directoryOnClick(<%=userHome.getId()%>, "<%=HTML.javaScriptEncode(userHome.getPath().toString())%>")', '', 'D<%=userHome.getId()%>');
			JoustMenu.menuItems[userHome].noOutlineIcon = true;
			JoustMenu.menuItems[userHome].isOpen = true;
			<%=generateSubTree(tree, userHome, ID, "userHome")%>
			<%
		}
		%>

		var root = JoustMenu.addMenuItem(-1, '<%=rootIcon%>', '<%=HTML.javaScriptEncode(rootTitle)%>', 'directoryOnClick(<%=root.getId()%>, "<%=HTML.javaScriptEncode(root.getPath().toString())%>")', '', 'D<%=root.getId()%>');
		JoustMenu.menuItems[root].noOutlineIcon = true;
		JoustMenu.menuItems[root].isOpen = true;
		<%=generateSubTree(tree, root, ID, "root")%>
		
		// Show directory separatly if read permission isn't granted all the way to root.
		if (!JoustMenu.menuItems['D<%=directoryId%>'])
		{
			<%
			try
			{
				Directory currentDir = Directory.getById(dc, directoryId);
				Map<Directory,List<Directory>> subTree = FileUtil.getDirectoryTree(dc, currentDir);
				%>
				var currentDir = JoustMenu.addMenuItem(0, 'Folder', '<%=HTML.javaScriptEncode(currentDir.getName())%>', 'directoryOnClick(<%=currentDir.getId()%>, "<%=HTML.javaScriptEncode(currentDir.getPath().toString())%>")', '', 'D<%=currentDir.getId()%>');
				JoustMenu.menuItems[currentDir].noOutlineIcon = true;
				JoustMenu.menuItems[currentDir].isOpen = true;
				<%=generateSubTree(subTree, currentDir, ID, "currentDir")%>
				<%
			}
			catch (Throwable ex){}			
			%>
		}
		JoustMenu.draw('joust');
		var lastDirectory;
		<%
		if (directoryId != 0)
		{
			%>
			lastDirectory = JoustMenu.menuItems['D<%=directoryId%>'];
			<%
		}
		%>
		JoustMenu.select(lastDirectory ? lastDirectory.index : <%=userHome != null ? "userHome" : "root"%>);
		JoustMenu.alwaysSendOnClickToSelected = true;
		isInitialised = true;
	}
	
	<%
	if ("selectonedirectory".equals(mode))
	{
		%>
		var lastDirectoryId;
		function directoryOnClick(directoryId, path)
		{
			var frm = document.forms['directory'];
			frm.directory_id.value = directoryId;
			frm.path.value = path;
			lastDirectoryId = directoryId;
		}
		function returnSelected()
		{
			var frm = document.forms['directory'];
			top.window.opener.<%=callback%>(frm.directory_id.value, frm.path.value);
			top.window.close();
		}
		function newDirectory()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', 0, true, '&parent_id='+lastDirectoryId);
		}
		<%
	}
	else
	{
		%>
		function directoryOnClick(directoryId, path)
		{
			if (!isInitialised && parent.frames.files.location.href.match('jsp')) return;
			parent.lastOpenDirectoryId = directoryId;
			parent.frames.files.location.href = '../files/index.jsp?ID=<%=ID%>&cmd=List&directory_id='+directoryId+'&mode=<%=mode%>';
			if (window.top.setSelected)
			{
				window.top.setSelected('', path);
			}
		}
		<%
	}
	%>
	function refresh()
	{
		location.reload();
	}
	</script>
	</base:head>
	
	<%
	if ("selectonedirectory".equals(mode))
	{
		%>
		<base:body onload="initialise()"
			style="padding-left: 0px; padding-right: 0px;"
			>
			<div id="main" class="joust" style="width:100%;">
				<h3 class="docked"><%=requestTitle == null ? "Select one directory" : requestTitle%></h3>
				<tbl:toolbar>
					<tbl:button 
						image="directory_new.gif" 
						onclick="newDirectory()" 
						title="New&hellip;" 
						tooltip="Create a new directory" 
					/>
				</tbl:toolbar>
				<div id="joust" class="boxedbottom" style="height: <%=(int)(scale*340)%>px; overflow:auto; background: #E0E0E0;">
				</div>
			</div>
			
			<form name="directory">
			<br>
			<input type="hidden" name="directory_id" value="">
			<b><%=requestTitle == null ? "Path" : requestTitle%></b> <input type="text" class="text" readonly name="path" size="40">
			<p>
			<table align="center">
			<tr>
				<td width="50%"><base:button onclick="returnSelected()" title="Ok" /></td>
				<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
			</tr>
			</table>
			</form>
		</base:body>
		<%
	}
	else
	{
		%>
		<base:body onload="initialise()" 
			style="border: 1px solid #999999; border-bottom: 0px; border-right: 0px; padding-left: 0px; padding-right: 0px;" >
		<div id="main" class="joust" style="width:100%;">
			<div id="joust" style="overflow: auto;">
			</div>
			<div style="width:99%;">
			<table align="center">
			<tr>
				<td><base:button onclick="refresh()" title="Refresh" image="refresh.gif" /></td>
			</tr>
			</table>
			</div>
		</div>
		</base:body>
		<%
	}
	%>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
