<%-- $Id: view_message.jsp 4511 2008-09-11 20:04:27Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Message"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ParameterInfo"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%!
	private static final Item itemType = Item.MESSAGE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"), "properties");
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Message message = Message.getById(dc, itemId);
	message.setRead(true);
	boolean readJob = true;
	Job job = null;
	boolean readCurrentConfig = true;
	PluginConfiguration currentConfig = null;
	try
	{
		job = message.getJob();
	}
	catch (Exception ex)
	{
		readJob = false;
		readCurrentConfig = false;
	}
	if (job != null)
	{
		try
		{
			currentConfig = job.getPluginConfiguration();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentConfig = false;
		}
	}
	
	String title = "Message -- " + HTML.encodeTags(message.getName());;
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	
	final boolean writePermission = message.hasPermission(Permission.WRITE);
	final boolean deletePermission = message.hasPermission(Permission.DELETE);
	final boolean isRemoved = message.isRemoved();
	final boolean isUsed = isRemoved && message.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css,progressbar.css">
	<script language="javascript">
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			location.href = getRoot() + 'common/close_popup.jsp?ID=<%=ID%>&refresh_opener=1&wait=0';
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
	</script>
	</base:head>
	<base:body>
		
		<h3 class="docked"><%=title%> <base:help tabcontrol="main" /></h3>
		<t:tabcontrol id="main" active="<%=tab%>" position="bottom" contentstyle="<%="height: "+(int)(scale*320)+"px;"%>">
		<t:tab id="properties" title="Properties" helpid="message.view.properties">

			<%
			if (message.isRemoved())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
				</div>
				<%
			}
			%>
			<table class="form" cellspacing=0>
			<tr valign="top">
				<td class="prompt">Subject</td>
				<td><%=HTML.encodeTags(message.getName())%></td>
			</tr>
			<tr valign="top">
				<td class="prompt">From</td>
				<td><%=HTML.encodeTags(message.getFrom())%></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Time sent</td>
				<td><%=dateTimeFormatter.format(message.getTimeSent())%></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Message</td>
				<td><%=HTML.niceFormat(message.getDescription())%></td>
			</tr>
			</table>
			</t:tab>
	
	<%
	if (job != null)
	{
		%>
		<t:tab id="job" title="Job" helpid="message.view.job">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(job.getName())%></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Description</td>
				<td>
					<%=HTML.encodeTags(job.getDescription())%>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Priority</td>
				<td>
					<%=job.getPriority()%> (1 = highest, 10 = lowest)
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Status</td>
				<td>
					<%=job.getStatus()%>: <%=HTML.niceFormat(job.getStatusMessage())%>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Percent complete</td>
				<td>
					<table border=0 cellspacing=0 cellpadding=0>
					<tr>
					<td width="100">
						<table width="100" class="progressbar" border=0 cellspacing=0 cellpadding=0>
						<tr>
							<%
							int percent = job.getPercentComplete();
							if (percent > 0) 
							{
								%>
								<td width="<%=percent%>%" class="done">&nbsp;</td>
								<% 
							}
							if (percent < 100) 
							{ 
								%>
								<td width="<%=100-percent%>%" class="remain">&nbsp;</td>
								<%
							}
							%>
						</tr>
						</table>
					</td>
					<td>&nbsp;<%=percent%>%</td>
					</tr>
					</table>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Created</td>
				<td>
					<%=dateTimeFormatter.format(job.getCreated())%>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Started</td>
				<td>
					<%=dateTimeFormatter.format(job.getStarted())%>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Ended</td>
				<td>
					<%=dateTimeFormatter.format(job.getEnded())%>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Server</td>
				<td>
					<%=HTML.encodeTags(job.getServer())%>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">User</td>
				<td>
					<base:propertyvalue item="<%=job%>" property="owner.name" />
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Experiment</td>
				<td>
					<base:propertyvalue item="<%=job%>" property="experiment.name" />
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Plugin</td>
				<td>
					<base:propertyvalue item="<%=job%>" property="pluginDefinition.name" />
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Configuration</td>
				<td>
					<base:propertyvalue item="<%=job%>" property="pluginConfiguration.name" />
				</td>
			</tr>
			</table>
		</t:tab>
		<%
		if (job.getStackTrace() != null)
		{
			%>
			<t:tab id="stacktrace" title="Stack trace" helpid="message.view.jobstacktrace">
				<div style="font-family: monospace">
				<%=HTML.niceFormat(job.getStackTrace())%>
				</div>
			</t:tab>
			<%
		}
		%>
		
		<t:tab id="Parameters" title="Parameters" helpid="message.view.jobparameters">
			<h4>Job parameters</h4>
			<table class="form" cellspacing=0>
				<%
				List<String> names = new java.util.ArrayList<String>(job.getParameterNames());
				Collections.sort(names);
				for (String name : names)
				{
					StringBuilder sb = new StringBuilder();
					String displayValue = "";
					String description = "";
					try
					{
						ParameterInfo pi = job.getParameterInfo(name);
						if (pi.getLabel() != null) name = HTML.encodeTags(pi.getLabel());
						description = HTML.encodeTags(pi.getDescription());
						List<?> values = pi.getValues();
						int i = 0;
						for (Object value : values)
						{
							if (value != null)
							{
								if (i > 0) sb.append(", ");
								i++;
								if (value instanceof BasicItem)
								{
									BasicItem item = (BasicItem)value;
									String itemName = "";
									if (item instanceof File)
									{
										itemName = ((File)item).getPath().toString();
									}
									else if (item instanceof Nameable)
									{
										itemName = ((Nameable)item).getName();
									}
									else
									{
										itemName = item.toString();
									}
									sb.append(HTML.encodeTags(itemName));
								}
								else if (value instanceof Date)
								{
									sb.append(dateFormatter.format((Date)value));
								}
								else
								{
									sb.append(HTML.encodeTags(value.toString()));
								}
							}
						}
						displayValue = sb.toString();
					}
					catch (Throwable ex)
					{
						displayValue = "<i>ERROR: "+ex.getMessage()+"</i>";
					}
					%>
					<tr>
						<td class="prompt"><span title="<%=description%>"><%=name%></span></td>
						<td>
							<%=displayValue%>
						</td>
					</tr>
					<%
				}
				%>
			</table>

				<%
				if (!readCurrentConfig)
				{
					%>
					<h4>Plugin configuration parameters</h4>
					<i>- denied -</i>
					<%
				}
				else if (currentConfig != null)
				{
					int parameterVersion = job.getParameterVersion();
					int currentVersion = currentConfig.getParameterVersion();
					%>
					<h4>Plugin configuration parameters</h4>
					<table class="form" cellspacing=0>
					<tr>
						<td class="prompt"><span 
							title="The version of the parmeters used for this job, current version in paranthesis">Parameter version</span></td>
						<td><%=parameterVersion%> (<%=currentVersion %>)</td>
					</tr>
					<%
					names = new java.util.ArrayList<String>(currentConfig.getParameterNames(parameterVersion));
					Collections.sort(names);
					for (String name : names)
					{
						StringBuilder sb = new StringBuilder();
						String displayValue = "";
						String description = "";
						try
						{
							ParameterInfo pi = currentConfig.getParameterInfo(name, parameterVersion);
							if (pi.getLabel() != null) name = HTML.encodeTags(pi.getLabel());
							description = HTML.encodeTags(pi.getDescription());
							List<?> values = pi.getValues();
							int i = 0;
							for (Object value : values)
							{
								if (value != null)
								{
									if (i > 0) sb.append(", ");
									i++;
									if (value instanceof BasicItem)
									{
										BasicItem item = (BasicItem)value;
										String itemName = "";
										if (item instanceof File)
										{
											itemName = ((File)item).getPath().toString();
										}
										else if (item instanceof Nameable)
										{
											itemName = ((Nameable)item).getName();
										}
										else
										{
											itemName = item.toString();
										}
										sb.append(HTML.encodeTags(itemName));
									}
									else if (value instanceof Date)
									{
										sb.append(dateFormatter.format((Date)value));
									}
									else
									{
										sb.append(HTML.encodeTags(value.toString()));
									}
								}
							}
							displayValue = sb.toString();
						}
						catch (Throwable ex)
						{
							displayValue = "<i>ERROR: "+ex.getMessage()+"</i>";
						}
						%>
						<tr>
							<td class="prompt"><span title="<%=description%>"><%=name%></span></td>
							<td>
								<%=displayValue%>
							</td>
						</tr>
						<%
					}
					%>
					</table>
					<%
				}
				%>
			
		</t:tab>
		<%
	}
	%>
		</t:tabcontrol>
			
		<base:buttongroup align="center">
			<base:button onclick="window.close()" title="Close" />
		</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.commit();
}

%>
